DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSDisplayedArea_PList Class Reference

the list of displayed area selections contained in a presentation state (internal use only). More...

## Public Member Functions
| DVPSDisplayedArea_PList ()
| default constructor
| DVPSDisplayedArea_PList (const DVPSDisplayedArea_PList &copy)
| copy constructor
DVPSDisplayedArea_PList * | clone ()
| clone method. More...
virtual | ~DVPSDisplayedArea_PList ()
| destructor
OFCondition | read (DcmItem &dset)
| reads a list of displayed area selections (DisplayedAreaSelectionSequence) from a DICOM dataset. More...
OFCondition | write (DcmItem &dset)
| writes the list of displayed area selections managed by this object to a DICOM dataset. More...
void | clear ()
| reset the object to initial state. More...
size_t | size () const
| gets the number of displayed area selections in this list. More...
DVPSDisplayedArea * | findDisplayedArea (const char *instanceUID, unsigned long frame)
| checks if an displayed area selection exists for the given image and frame. More...
DVPSDisplayedArea * | createDisplayedArea (DVPSReferencedSeries_PList &allReferences, const char *sopclassUID, const char *instanceUID, unsigned long frame, unsigned long numberOfFrames, DVPSObjectApplicability applicability)
| finds or creates a displayed area selection SQ item with an applicability controlled by the applicability, instanceUID and frame parameters. More...
void | rotateAndFlip (DVPSRotationType rotationFrom, OFBool isFlippedFrom, DVPSRotationType rotationTo, OFBool isFlippedTo)
| adjusts all displayed area coordinates for the rotation and flipping status of the image. More...

## Private Member Functions
DVPSDisplayedArea_PList & | operator= (const DVPSDisplayedArea_PList &)
| private undefined assignment operator

## Private Attributes
OFList< DVPSDisplayedArea * > | list_
| the list maintained by this object

## Detailed Description

the list of displayed area selections contained in a presentation state (internal use only).

This class manages the data structures comprising one complete displayed area selection sequence contained in a presentation state object.

## Member Function Documentation

## ◆ clear()

void DVPSDisplayedArea_PList::clear | ( |  | ) |

reset the object to initial state.

After this call, the object is in the same state as after creation with the default constructor.

## ◆ clone()

DVPSDisplayedArea_PList* DVPSDisplayedArea_PList::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSDisplayedArea_PList object containing a deep copy of this object.

## ◆ createDisplayedArea()

DVPSDisplayedArea* DVPSDisplayedArea_PList::createDisplayedArea | ( | DVPSReferencedSeries_PList & | allReferences,
|  | const char * | sopclassUID,
|  | const char * | instanceUID,
|  | unsigned long | frame,
|  | unsigned long | numberOfFrames,
|  | DVPSObjectApplicability | applicability
| ) |  |

finds or creates a displayed area selection SQ item with an applicability controlled by the applicability, instanceUID and frame parameters.

The displayed area selection sequence is rearranged such that all other referenced images/frames keep their old displayed area settings.

Parameters

  allReferences | list of series/instance references registered for the presentation state.
  sopclassUID | SOP class UID of the current image
  instanceUID | SOP instance UID of the current image
  frame | number of the current frame
  numberOfFrames | number of frames of the current image
  applicability | applicability of the new displayed area selection

Returns
  pointer to a displayed area selection object from the list that matches the applicability parameters. NULL is returned if out of memory.

## ◆ findDisplayedArea()

DVPSDisplayedArea* DVPSDisplayedArea_PList::findDisplayedArea | ( | const char * | instanceUID,
|  | unsigned long | frame
| ) |  |

checks if an displayed area selection exists for the given image and frame.

Parameters

  instanceUID | SOP instance UID of the current image
  frame | number of the current frame

Returns
  pointer to the displayed area if it exists, NULL otherwise.

## ◆ read()

OFCondition DVPSDisplayedArea_PList::read | ( | DcmItem & | dset | ) |

reads a list of displayed area selections (DisplayedAreaSelectionSequence) from a DICOM dataset.

The DICOM elements of the displayed area selection item are copied from the dataset to this object. The completeness of all items (presence of all required elements, value multiplicity) is checked. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset from which the sequence is to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ rotateAndFlip()

void DVPSDisplayedArea_PList::rotateAndFlip | ( | DVPSRotationType | rotationFrom,
|  | OFBool | isFlippedFrom,
|  | DVPSRotationType | rotationTo,
|  | OFBool | isFlippedTo
| ) |  |

adjusts all displayed area coordinates for the rotation and flipping status of the image.

Parameters

  rotationFrom | previous rotation
  isFlippedFrom | previous flip status
  rotationTo | new rotation
  isFlippedTo | new flip status

## ◆ size()

size_t DVPSDisplayedArea_PList::size | ( |  | ) | const
| inline

gets the number of displayed area selections in this list.

Returns
  the number of displayed area selections.

## ◆ write()

OFCondition DVPSDisplayedArea_PList::write | ( | DcmItem & | dset | ) |

writes the list of displayed area selections managed by this object to a DICOM dataset.

Copies of the DICOM elements managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the DICOM dataset to which the DisplayedAreaSelectionSequence is written

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpsdal.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1